﻿using System;
using System.Windows;
using Microsoft.Phone;
using Microsoft.Phone.Scheduler;
using Microsoft.Phone.Shell;



namespace ScheduledTaskAgent1
{
    public class ScheduledAgent : ScheduledTaskAgent
    {
        private static volatile bool _classInitialized;

        /// <remarks>
        /// Costruttore ScheduledAgent, inizializza il gestore UnhandledException
        /// </remarks>
        public ScheduledAgent()
        {
            if (!_classInitialized)
            {
                _classInitialized = true;
                // La sottoscrizione del gestore eccezioni gestite
                Deployment.Current.Dispatcher.BeginInvoke(delegate
                {
                    Application.Current.UnhandledException += ScheduledAgent_UnhandledException;
                });
            }
        }

        /// Codice da eseguire in caso di eccezioni non gestite
        private void ScheduledAgent_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            if (System.Diagnostics.Debugger.IsAttached)
            {
                // Si è verificata un'eccezione non gestita; inserire un'interruzione nel debugger
                System.Diagnostics.Debugger.Break();
            }
        }

        /// <summary>
        /// Agente che esegue un'attività pianificata
        /// </summary>
        /// <param name="task">
        /// L'attività richiamata
        /// </param>
        /// <remarks>
        /// Questo metodo viene chiamato quando viene richiamata un'attività a elevato utilizzo di risorse o periodica
        /// </remarks>
        protected override void OnInvoke(ScheduledTask task)
        {
            //TODO: Add code to perform your task in background
            string toastMessage = "Contenuto";

            // Launch a toast to show that the agent is running.
            // The toast will not be shown if the foreground application is running.
            ShellToast toast = new ShellToast();
            toast.Title = "Titolo";
            toast.Content = toastMessage;
            toast.Show();

            NotifyComplete();
        }
    }
}